/**
 * SidePanelExampleMod
 *
 * A small example on how to add a component to the CMapWindow Side Panel.
 *
 * @author      Marco Arguedas      <marguedas@ai.uwf.edu>
 *
 * Created on May 23, 2003, 12:10pm
 *
 * @version     $Revision: 1.4 $
 *              $Date: 2006/10/16 23:58:05 $
 *
 * (based on nlk/suggestions/SuggestionsMod.java)
 */

package coi.cmap;

import core.base.Module;
import nlk.cmap.CMapWnd;
import nlk.cmapSidePanel.CMapSidePanel;
import nlk.cmapSidePanel.CMapSidePanelButton;
import nlk.code.TemplateSidePanelMod;
import nlk.exception.DuplicateElementXcp;

import javax.swing.*;
import java.awt.*;

/**
 * This is an extension of the TemplateSidePanelMod in the aspect of using specilized for COI class to build 
 * the list of templates
 */
public class COITemplateSidePanelMod extends TemplateSidePanelMod implements Module
{
    public COITemplateSidePanelMod()
    {
        super();
    }

    public String getName()
    {
        return "COITemplateSidePanelMod";
    }

    public String getVersion()
    {
        return "1.0";
    }

    public String getDescription()
    {
        return "COITemplateSidePanelMod";
    }

    public String getAuthorAddress()
    {
        return "auszok@ihmc.us";
    }
    
    /**
     * This method adds a component to the side panel.
     *
     * Currently, it adds only a JList.
     */
    protected void addComponentToSidePanel(CMapWnd cmw)
    {
        CMapSidePanel sidePanel = cmw.getSidePanel();
        CMapSidePanelButton spButton = sidePanel.getSidePanelButton(COI_BUTTON_TYPE);

        if (spButton == null) 
        {
            myTemplatelist = new COITemplateDNDList(this, cmw.getResourceInfo());
            myTemplatelist.setMinimumSize(new Dimension(100, 100));

            try 
            {
                ImageIcon imageIcon = new ImageIcon(getClass().getResource("images/icons/templateCOI.gif"));
                sidePanel.addSidePanelButton(imageIcon, //the regular icon
                                             imageIcon, //image for the icon when rollover
                                             imageIcon, //image for the icon when pressed
                                             "COI Templates",                                                      // the text shown in the title of the panel
                                             COI_BUTTON_TYPE,                                                      // the type of the button
                                             myTemplatelist,                                                                 // the component to be added.
                                             this,                                                                 //owner module of the CMapSidePanelButton
                                             5000                                                                  //position of the button in the SidePanel.
                                             );

                //adds the component to the control table.
                _panelsControlTable.put(cmw, myTemplatelist);
            }
            catch (DuplicateElementXcp ex) 
            {
            }
        }
    }
    /**
     * String that identifies the type of the Suggestions CMapSidePanelButton
     */
    public static String COI_BUTTON_TYPE = "COITemplateSidePanel";
}
