/*
 * OntologyPartWriter.java
 *
 * Created on September 25, 2006, 5:39 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package coi.cmap;

import nlk.base.ConceptMap;
import nlk.base.GraphicalConceptMap;
import nlk.base.PartWriter;
import nlk.base.PartWriterData;
import nlk.code.owlexport.CodeCmapParser;
import nlk.code.owlimport.NameSpaceTable;
import nlk.util.CMapComponent;
import nlk.util.CMapSettings;
import nlk.util.FolderFetcher;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Hashtable;
import java.util.Vector;


/**
 *
 * @author jlott
 */
public class OntologyPartWriter implements PartWriter
{
    
    /**
     * Creates a new instance of OntologyPartWriter
     */
    public OntologyPartWriter()
    {
    }

    public Vector getData(Object object, Hashtable hashtable)
    {
        if (!(object instanceof ConceptMap)) {
            return null;
        }
        
        ConceptMap cmap = (ConceptMap) object;
        NameSpaceTable myNameSpaceTable = NameSpaceTable.getMappingsFromCmap(cmap);
        if (myNameSpaceTable.getMapping("") == null)
        {
            String myMapOWLURL = FolderFetcher.getURLToResource(cmap.getResourceInfoRef().getCachedServerId(), cmap.getResourceInfoRef().getResourceId())+ "&partName=owl";
            myNameSpaceTable.addMapping("", myMapOWLURL + "#");
        }
        
        NameSpaceTable.addMappingsToCmap(myNameSpaceTable, cmap);
        
        String tempFileName = CMapSettings.getCMapSettings().getWorkingDirectory() + File.separator + cmap.getResourceInfoRef().getResourceName() + ".owl";
        try {
            File tempFile = new File(tempFileName);
            tempFile.deleteOnExit();
            FileOutputStream fos = new FileOutputStream(tempFile);
            CodeCmapParser parser = new CodeCmapParser(new CMapComponent((GraphicalConceptMap)cmap.getSelectedGraphicalRepRef()),
                                                       fos,
                                                       nlk.code.Constants.DEFAULT_ONTOLOGY_FORMAT,
                                                       false);
            fos.close();
            PartWriterData data = new PartWriterData("owl","text/plain", tempFileName);
            Vector v = new Vector();
            v.add(data);
            return v;
        }
        catch (Exception xcp) {
            xcp.printStackTrace();
        }
        return null;
    }
    
}
