/**
 * @author uszok
 * On: $Date: 2006/10/29 01:59:57 $
 * 
 * $Revision: 1.2 $.
 */

package coi.cmap;

import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.GridLayout;

import javax.swing.BoxLayout;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;

import nlk.util.GeneralUtils;

public class TemplatePropertyLDlg extends JDialog
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = -1811652546059803703L;
    
    private TemplatePropertyLDlg       _thisDlg;
    private JLabel          _sourceMapIDLabel;
    private JLabel          _templateOntologyTypeLabel;
    private JButton         _okButton;
    private JButton         _cancelButton;
    private COIMod          _mod;
    private JFrame          _pframe;
    private JTextField      _mySourceMapID;
    private String          _myTemplateOntologyType;
    private JRadioButton    _templateOntologyTypeClass;
    private JRadioButton    _templateOntologyTypeInstance;
    private ButtonGroup     _templateOntologyTypeGroup;
    private boolean         _okayed;
    
      
    public TemplatePropertyLDlg (JFrame parentFrame, COIMod mod, String _sourceMapID, String _templateOntologyType)
    {
        super (parentFrame);
        _thisDlg = this;
        _pframe = parentFrame;
        _mod = mod;
        
        initComponents (_sourceMapID, _templateOntologyType);        
    }

    private void initComponents(String _sourceMapID, String _templateOntologyType)
    {
        final Insets PBUTTON_TXT_INSETS = new Insets (1, 12, 1, 12);
        Font dialog_font  = GeneralUtils.FONT_TAHOMA_11;
        _okayed = false;
        
        _sourceMapIDLabel          = new JLabel ("Template Source Ontology Cmap Id: ");
        _templateOntologyTypeLabel = new JLabel ("Type of Template: ");
        _okButton     = new JButton ("Ok");
        _cancelButton = new JButton ("Cancel");
        
        _okButton.setMargin        (PBUTTON_TXT_INSETS);
        _cancelButton.setMargin    (PBUTTON_TXT_INSETS);
        
        _sourceMapIDLabel.setFont  (dialog_font);
        _templateOntologyTypeLabel.setFont  (dialog_font);
        
        _okButton.setFont        (dialog_font);
        _cancelButton.setFont    (dialog_font);
        
        _mySourceMapID = new JTextField ((_sourceMapID==null? "": _sourceMapID));
        _mySourceMapID.setFont (dialog_font);
        _mySourceMapID.setColumns (35);
        _mySourceMapID.setAutoscrolls (true);
        
        _templateOntologyTypeClass = new JRadioButton("Template to build COI related subclasses");
        _templateOntologyTypeClass.setActionCommand(COIMod.SPECIFIC_TYPE);
        _templateOntologyTypeClass.setSelected(true);
        
        _templateOntologyTypeInstance = new JRadioButton("Template to build COI related instances");
        _templateOntologyTypeInstance.setActionCommand(COIMod.IMPLEMENTED_TYPE);
        if (_templateOntologyType.equals(COIMod.IMPLEMENTED_TYPE))
        {
            _templateOntologyTypeClass.setSelected(false);
            _templateOntologyTypeInstance.setSelected(true);
        }
            
        
        _templateOntologyTypeGroup = new ButtonGroup();
        _templateOntologyTypeGroup.add(_templateOntologyTypeClass);
        _templateOntologyTypeGroup.add(_templateOntologyTypeInstance);
        
        _templateOntologyTypeClass.addActionListener (new ActionListener() 
        {
            public void actionPerformed (ActionEvent e) 
            {
                _myTemplateOntologyType = COIMod.SPECIFIC_TYPE;
            }
        });
        
        _templateOntologyTypeInstance.addActionListener (new ActionListener() 
        {
            public void actionPerformed (ActionEvent e) 
            {
                _myTemplateOntologyType = COIMod.IMPLEMENTED_TYPE;
            }
        });
        
        JPanel radioPanel = new JPanel(new GridLayout(0, 1));
        radioPanel.add(_templateOntologyTypeClass);
        radioPanel.add(_templateOntologyTypeInstance);
        
        _okButton.addActionListener (new ActionListener() 
        {
            public void actionPerformed (ActionEvent e) 
            {
                _okayed = true;
                setVisible (false);
            }
        });
        
        _cancelButton.addActionListener (new ActionListener() 
        {
            public void actionPerformed (ActionEvent e) 
            {
                _okayed = false;
                setVisible (false);
            }
        });

        _mySourceMapID.addKeyListener (new KeyListener() 
        {
            public void keyTyped    (KeyEvent k) { checkNullTextAndCtrlFG (k, true); }
            public void keyPressed  (KeyEvent k) { checkNullTextAndCtrlFG (k, false); }
            public void keyReleased (KeyEvent k) { checkNullTextAndCtrlFG (k, false); }
        });

        // the following code sets the dlg's initial state
        JPanel buttonPanel = new JPanel ();
        buttonPanel.setLayout (new BoxLayout (buttonPanel, BoxLayout.X_AXIS));
        buttonPanel.add (_okButton);
        JLabel sep1 = new JLabel ("");
        JLabel sep2 = new JLabel ("");
        sep1.setBorder (new EmptyBorder (0,12,0,0));
        buttonPanel.add (sep1);
        buttonPanel.add (_cancelButton);
        buttonPanel.setBorder (new EmptyBorder (18, 0, 8, 0));
        JPanel mainPanel = new JPanel();
        
        GridBagConstraints c = new GridBagConstraints();
        mainPanel.setLayout (new GridBagLayout());
        c.anchor    = c.CENTER;
        c.fill      = c.BOTH;
        c.gridx     = 0;
        c.gridy     = 0;
        c.gridwidth = 1;
        mainPanel.add (_sourceMapIDLabel, c);
        c.gridx     = 1;
        c.gridwidth = 3;
        mainPanel.add (_mySourceMapID, c);
        c.gridwidth = 2;
        c.gridx     = 0;
        c.gridy     = 1;
        mainPanel.add (radioPanel, c);
        c.gridwidth = 4;
        c.gridx     = 0;
        c.gridy     = 1;
        c.anchor    = c.EAST;
        c.fill      = c.NONE;
        mainPanel.add (buttonPanel, c);
        mainPanel.setBorder (new EmptyBorder (18, 12, 0, 12));
        
        setTitle ("COI Template Properties Editor");
        setContentPane (mainPanel);
        setModal (true);
        setResizable (false);
        setLocationRelativeTo (getParent ());
        getRootPane().setDefaultButton (_okButton);
        pack();
        core.util.SysUtils.centerDialog (this, _pframe);
    }

    private void checkNullTextAndCtrlFG (KeyEvent kev, boolean testCtrlFG)
    {
        if (_mySourceMapID.getText ().equals ("")) 
        {
            _okButton.setEnabled (false);
            return;
        }
        
        // Text to find is not null or empty
        _okButton.setEnabled (true);
        
        if (!testCtrlFG) 
            return;
    }
    
    boolean wasOkayed ()
    {
        return _okayed;
    }

    public String getSourceMapID() 
    {
        return _mySourceMapID.getText();
    }

    public String getTemplateOntologyType() 
    {
        return _myTemplateOntologyType;
    }
}
