package coi.cmap.monitor;

import coi.cmap.bootstrap.BootstrapViewerDlg;
import core.base.Core;
import core.base.CorePopup;
import core.base.Module;
import core.event.MenuItemEvt;
import core.exception.EvtHandlersFailedXcp;
import core.exception.InvalidParameterXcp;
import core.util.CoreOptionPane;
import core.util.CoreProgressDialog;
import nlk.base.*;
import nlk.code.CodeStyles;
import nlk.code.Constants;
import nlk.code.align.AlignPanel;
import nlk.code.inst.InstancePropositionHelper;
import nlk.event.cmap.CMapDeselectAllEntitiesEvt;
import nlk.event.cmap.CMapRepaintAllEntitiesEvt;
import nlk.refactor.RefactorMod;
import nlk.util.CMapComponent;
import nlk.util.FolderFetcher;

import javax.swing.*;
import java.awt.*;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: Oct 4, 2006
 * Time: 4:31:47 PM
 * To change this template use File | Settings | File Templates.
 */
public class MonitorMapViewer
{

    private CMapComponent _cmc;
    private Module _module;
    private Core _core;
    private InstancePropositionHelper _iph;
    private MonitorMapHelper _mmh;

    public MonitorMapViewer(CMapComponent cmc, Module module, Core core, MonitorMapHelper mmh)
    {
        this._cmc = cmc;
        this._module = module;
        this._core = core;
        this._mmh = mmh;

        this._iph = new InstancePropositionHelper(_cmc, _core);

        instanceToBigNode();
    }
    public void handleKAoSEvt(MenuItemEvt evt) throws Exception
    {
        System.out.println("You chose " + evt.menuSpec);

        CorePopup cpopup = (CorePopup) evt.menuContainer;
        CMapComponent cmc = (CMapComponent) cpopup.getPopupComponent();
        GraphicalConceptMap gcm = cmc.getGraphicalConceptMapRef();
         ConceptMap cm = gcm.getConceptMapRef();

         Enumeration en = cmc.getSelectedGraphicalEntitys();
         while ( en.hasMoreElements())
         {
             GraphicalEntity e = (GraphicalEntity) en.nextElement();
             if ( e instanceof GraphicalConcept )
             {
                 GraphicalConcept gc = (GraphicalConcept) e;
                 Concept c = gc.getConceptRef();
                 Object type = c.get(Constants.NODE_TYPE);
                 String kaosid = "urn:KAoS#" + c.getLabel();
                 String kaosidLong = (String) c.get("COMMENT_DISPLAY");     // try the long display name if the short one doesn't work
                 if ( type != null )
                 {
                     if (( (type != null ) && ( type instanceof String ) && ( ((String)type).equals(Constants.INDIV))) ||
                         ( (type != null ) && ( type instanceof ExtVector) && (((ExtVector)type).contains(Constants.INDIV))))
                     {
                        if (evt.menuSpec.equals("KAoS/bs/ShowBootstrapFile"))
                        {
                            System.out.println("Show the bootstrap file for " + c.getLabel());
                            BootstrapViewerDlg bvd = new BootstrapViewerDlg(kaosid,"This is where the bootstrap file goes");
                            bvd.pack();
                            bvd.setVisible(true);

                            JFrame jf = new JFrame();
                            AlignPanel ap = new AlignPanel(cm);
                            jf.getContentPane().add( ap.getMainPanel());
                            jf.pack();
                            jf.setVisible(true);

                        }
                        else if (evt.menuSpec.equals("KAoS/ShowPolicies"))
                        {
                            System.out.println("Show the policies for " + kaosid);
                            if ( _mmh != null )
                            {
                                Hashtable m = (Hashtable) _mmh.getActorPoliciesInOWL(kaosid);
                                if (m.isEmpty())
                                {
                                    m = (Hashtable) _mmh.getActorPoliciesInOWL(kaosidLong);
                                    if ( m.isEmpty())
                                        CoreOptionPane.showMessage("No Policies", "No policies defined for " + kaosid, CoreOptionPane.WARNING);
                                    else
                                    showPolicyViewer(m);
                                }
                                else
                                {
                                    showPolicyViewer(m);
                                }
                            }
                            else
                            {
                                CoreOptionPane.showMessage("Error", "Cannot contact KAoS", CoreOptionPane.ERROR);
                            }
                        }
                        else if (evt.menuSpec.equals("KAoS/ShowInfo"))
                        {
                            System.out.println("Show info for " + kaosid);
                            // here is were we will call relationInfoGUi
                            RelationInfoDlg rig = new RelationInfoDlg();
                            rig.setVisible(true);
/*                            List actions = _mmh.getActions(kaosid);
                            if ( actions != null )
                            {
                                for (int i = 0; i < actions.size(); i++)
                                {
                                    Object o = actions.get(i);
                                    System.out.println("Action " + o);
                                }
                            }
*/
                        }
                        else if (evt.menuSpec.equals("KAoS/ShowRelations"))
                        {
                            System.out.println("Show info for " + kaosid);
                            Hashtable fromHt = (Hashtable) c.getTrans("fromIdChannels");
                            //Vector toVec = (Vector) c.getTrans("toIdChannels");
                            
                            RelationInfoDlg rig = new RelationInfoDlg(kaosidLong, fromHt, _mmh);
                            rig.pack();
                            rig.setVisible(true);
                        }
                         else
                        {
                            System.out.println("Cannot handle " + evt.menuSpec);
                        }
                     }
                 }
             }
             else if ( e instanceof GraphicalLinkingPhrase )
             {
                 GraphicalLinkingPhrase glp = (GraphicalLinkingPhrase) e;
                 String side1 = "";
                 String side2 = "";
                 for (Enumeration cons = glp.getLinkingPhraseRef().getIncomingConnectionRefs(); cons.hasMoreElements();)
                 {
                     Connection con = (Connection) cons.nextElement();
                     Node n1 = con.getFirstNodeRef();
                     if ( n1 instanceof Concept )
                     {
                         Concept cn1 = (Concept) n1;
                         side1 = (String) cn1.get("COMMENT_DISPLAY");
                     }
                     if ( side1 == null )
                     {
                         Node pbn1 = n1.getParentBigNodeRef();
                         if ( pbn1 != null )
                         {
                             side1 = (String) pbn1.get("COMMENT_DISPLAY");
                         }
                     }
                     else
                         side1 = (String ) n1.get("COMMENT_DISPLAY");
                 }
                 for (Enumeration cons = glp.getLinkingPhraseRef().getOutgoingConnectionRefs(); cons.hasMoreElements();)
                 {
                     Connection con = (Connection) cons.nextElement();
                     Node n2 = con.getSecondNodeRef();
                     if ( n2 instanceof Concept )
                     {
                         Concept cn2 = (Concept) n2;
                         side2 = (String) cn2.get("COMMENT_DISPLAY");
                     }
                     if ( side2 == null )
                     {
                         Node pbn2 = n2.getParentBigNodeRef();
                         if ( pbn2 != null )
                         {
                             side2 = (String) pbn2.get("COMMENT_DISPLAY");
                         }
                     }
                     else
                         side2 = (String) n2.get("COMMENT_DISPLAY");
                 }

                 if (evt.menuSpec.equals("KAoS/ShowRelation"))   // from a linking phrase
                 {
                     // get the two endpoints
                     // look up the relation info between them
                     // Display the relation info

                     String fromIdChannel = (String) glp.getEntityRef().getTrans("fromChannel");
                     String toIdChannel = (String) glp.getEntityRef().getTrans("toChannel");

                     System.out.println("Show info for " + side1 + " and " + side2);
                     if (( side1 != null ) && ( side2 != null))
                     {
                         RelationInfoDlg rig = new RelationInfoDlg(side1,fromIdChannel,side2,toIdChannel, _mmh);
                         rig.pack();
                         rig.setVisible(true);
                     }
                 }

             }
         }


    }

    private void showPolicyViewer(Hashtable m)
    {
        PolicyViewer pv = new PolicyViewer(_core);
        pv.initialize(m);
        pv.setVisible(true);
    }

    public void instanceToBigNode()
    {
        CoreProgressDialog cpd = new CoreProgressDialog("Configuring Monitored Map","Collapsing actor groups","",CoreProgressDialog.WAIT,_cmc.getContainingCoreWnd(), false);
        cpd.showDialog(CoreProgressDialog.CENTER_ON_PARENT, true);
        RefactorMod rm = RefactorMod.getRefactorMod();
        rm.set_cmc(_cmc);
        Enumeration initialConcepts = _cmc.getGraphicalConceptMapRef().getConceptMapRef().getConceptRefs();

        for (Enumeration e = initialConcepts; e.hasMoreElements();)
        {
            Concept c = (Concept) e.nextElement();
            GraphicalConcept gc = (GraphicalConcept) c.getGraphicalRepRefs().nextElement();
            Object nodeType = c.get(Constants.NODE_TYPE);
            if (( nodeType != null ) && (! c.isBigNode()))
            {
                if ((( nodeType instanceof String ) && (nodeType.equals(Constants.INDIV))) ||
                    (( nodeType instanceof ExtVector)) && ( ((ExtVector)nodeType).contains(Constants.INDIV)))
                {
                    rm.postSelect(gc);
                    rm.selectSubtree(gc,-1);
                    //rm.selectSuptree(gc,-1);
                    rm.copySelectedAndCreateNestedNode(_cmc);
                }

                CMapDeselectAllEntitiesEvt dae = new CMapDeselectAllEntitiesEvt(_module);
                dae._cmapComp = _cmc;

                try
                {
                    _core.postModuleEvt(dae);
                }
                catch (EvtHandlersFailedXcp evtHandlersFailedXcp)
                {
                    evtHandlersFailedXcp.printStackTrace();
                }
                catch (InvalidParameterXcp invalidParameterXcp)
                {
                    invalidParameterXcp.printStackTrace();
                }
            }
        }
        cpd.dispose();
    }

    public void instanceToBigNode2()
    {
        RefactorMod rm = RefactorMod.getRefactorMod();
        rm.set_cmc(_cmc);
        for (Enumeration e = _cmc.getGraphicalConceptMapRef().getConceptMapRef().getConceptRefs(); e.hasMoreElements();)
        {
            Concept c = (Concept) e.nextElement();
            GraphicalConcept gc = (GraphicalConcept) c.getGraphicalRepRefs().nextElement();
            Object nodeType = c.get(Constants.NODE_TYPE);
            if (( nodeType != null ) && (! c.isBigNode()))
            {
                if ((( nodeType instanceof String ) && (nodeType.equals(Constants.INDIV))) ||
                    (( nodeType instanceof ExtVector)) && ( ((ExtVector)nodeType).contains(Constants.INDIV)))
                {
                    rm.postSelect(gc);
                    rm.selectSubtree(gc,-1);
                    rm.selectSuptree(gc,-1);
                    rm.copySelectedAndCreateNestedNode(_cmc);
                }
            }
        }
    }
    public void entityRegistered(String kaosId, List ontologicalTypes, List domains)
    {
        System.out.println("\n\n\n Entity Registered Called  \n\n\n");
        // we need to see if it's present in the map, and if not add it
        String id = extractDisplayName(kaosId);


        Concept idConcept;

        idConcept = _iph.findBNMatchingConcept(id);

        if ( idConcept == null )
        {
            System.out.println("Finding regular node for id " + id);
            idConcept = _iph.findMatchingConcept(id);
        }
        else
        {
            System.out.println("Found a big node for id " + id );
        }
        
        GraphicalConcept gc = null;


        if ( idConcept == null )
        {
            // we have to create it as a new node

            // first, check to see if it's in the correct domain.
            String domain = findMonitorMapDomain();
            if (domain == null)
            {
                CoreOptionPane.showMessage("Warning", "Cannot determine domain of monitored map. Adding all registered agents", CoreOptionPane.WARNING);
            }

            List newNodeDomains = null;
            try
            {
                newNodeDomains = _mmh.getActorDomains(kaosId);
            }
            catch (Exception e)
            {
                e.printStackTrace();
            }
            if ((domain == null ) || ((newNodeDomains != null ) &&  (newNodeDomains.isEmpty())) || ((newNodeDomains != null ) &&  newNodeDomains.contains(domain)))
            {
                idConcept = new Concept(id);
                gc = new GraphicalConcept(idConcept);
                _iph.addConcept(gc);

                highlightConcept( idConcept,new ExtColor(Color.GRAY ), new Integer(3));
            }
        }
        else
        {
            highlightConcept(idConcept, new ExtColor(Color.GREEN), new Integer(4));

        }
    }

    private void highlightConcept(Concept idConcept, Color col, Integer thickness )
    {
        try
        {
            GraphicalConcept gc = (GraphicalConcept) idConcept.getGraphicalRepRefs().nextElement();
            StyleSheet ss = gc.getStyleSheet();
            if ( ss == null )
            {
                ss = CodeStyles.getClassNodeStyles();
            }
            if ( idConcept.getTrans("oldColor") == null )           // make sure we keep the original color
            {
                idConcept.putTrans("oldColor",ss.get(GraphicalConcept.CONCEPT_BORDER_COLOR));
                idConcept.putTrans("oldThickness", ss.get(GraphicalConcept.CONCEPT_BORDER_THICKNESS ));
            }


            ss.put (GraphicalConcept.CONCEPT_BORDER_COLOR,     col);
            ss.put (GraphicalConcept.CONCEPT_BORDER_THICKNESS, thickness);

            gc.setStyleSheet(ss);

            //gc.getGraphicalConceptMapRef().computeGraphicalData(new DrawingContext());
            CMapRepaintAllEntitiesEvt crae = new CMapRepaintAllEntitiesEvt(_module);
            crae._cmapComp = _cmc;

            _core.postModuleEvt (crae);
        }
        catch (Exception xcp) {
            System.out.println ("stack trace in MontiorMapViewer.highlightConcept");
            xcp.printStackTrace();
        }
    }

    private boolean mapContainsDomainName(ResourceInfo actorMap, ResourceInfo otherMap )
    {
        String actorName = actorMap.getResourceName();
        String otherName = otherMap.getResourceName();
        System.out.println("++++++++++++++++ Map Contains " + actorName + "||||" + otherName);
        return ((! actorName.equals( otherName )) && (actorName.startsWith(otherName) && (otherMap.getResourceMIMETypeRef().getMajorType().equals("x-cmap"))));
    }

    private String findMonitorMapDomain()
    {
        ResourceInfo ri = _cmc.getGraphicalConceptMapRef().getConceptMapRef().getResourceInfoRef();
        FolderFetcher ff = new FolderFetcher(_core,_module);
        ConceptMap cm = null;
        try
        {
        	Vector parentFolders = ff.getParentResourceInfos(ri.getCachedServerId(),ri.getCachedProjectId(),ri.getResourceId());
        	if (parentFolders != null && parentFolders.size() >= 1)
        	{
        		ResourceInfo parentFolder = (ResourceInfo)parentFolders.elementAt(1);
                Vector siblingMaps = ff.getFolderTOC(ri.getCachedServerId(),parentFolder.getCachedProjectId(),"guest","guest",null );
                
                for (int i = 0; i < siblingMaps.size(); i++)
                {
                    ResourceInfo siblingRI = (ResourceInfo) siblingMaps.elementAt(i);
                    if ( mapContainsDomainName( ri, siblingRI))
                    {
                        ResourceReader siblingRR = ff.getResourceReader(siblingRI.getCachedServerId(), siblingRI.getCachedProjectId(), siblingRI.getResourceId());
                        try
                        {
                            cm = (ConceptMap) siblingRR.readResource();
                        }
                        catch (java.lang.Exception jle)
                        {
                            System.out.println("MonitorMapViewer.findMonitorMapDomain: Caught an exception reading resource from " + siblingRR + " : " + jle);
                            jle.printStackTrace();
                        }
                        catch (java.lang.Throwable t)           // we want to keep this catch of a throwable so that we can at least note the title of the resource
                        {
                            System.out.println("MonitorMapViewer.findMonitorMapDomain: Ran out of memory reading concept map resource " + t);
                            t.printStackTrace();
                        }
                        if (cm != null)
                        {
                            return getDomainInstance( cm );
                        }
                    }

                }        	
            }
        	else
        	{
        		return null;
        	}

        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

       return null;
    }

    private String getDomainInstance( ConceptMap cm )
    {
        for (Enumeration e=cm.getConceptRefs(); e.hasMoreElements();)
        {
            Concept concept = (Concept) e.nextElement();

            // TODO: right now, lets just look for the instance node, but we need to do something smarter here

            Object o = concept.get(Constants.NODE_TYPE);
            if ( o != null )
            {
                if (( o instanceof ExtVector ) && ((ExtVector) o).contains(Constants.INDIV))
                {
                    return concept.getLabel();
                }
                else if (( o instanceof String ) && ((String)o).equals(Constants.INDIV))
                {
                    return concept.getLabel();
                }
            }
        }
        return null;
    }

    private String extractDisplayName(String id)
    {
        // first strip the URN off of it
        int i = id.lastIndexOf("#");
        if ( i >= 0 )
            id = id.substring(i+1);
        return id;
    }

    public void entityDeregistered(String id)
    {
        // remove it from the map by showing it in deregistered style
        // we need to see if it's present in the map, and if not add it
        id = extractDisplayName(id);
        Concept idConcept;

        idConcept = _iph.findBNMatchingConcept(id);

        if ( idConcept == null )
        {
            System.out.println("Finding regular node for id " + id);
            idConcept = _iph.findMatchingConcept(id);
        }
        else
        {
            System.out.println("Found a big node for id " + id );
        }


         if ( idConcept == null )
         {
             // it's not on the map, so we don't delete it, TODO: what should we do here?
         }
         else
         {
             // it's there already, put a deregisteredStyle on it

             GraphicalConcept gc = (GraphicalConcept) idConcept.getGraphicalRepRefs().nextElement();

             Color col = (Color) idConcept.getTrans("oldColor");
             if (col == null )
             {
                 col = (Color) gc.getStyleSheet().get(GraphicalConcept.CONCEPT_BORDER_COLOR);
             }

             Integer thickness;

             thickness = (Integer) idConcept.getTrans("oldThickness");
             if ( thickness == null )
             {
                 thickness = (Integer) gc.getStyleSheet().get(GraphicalConcept.CONCEPT_BORDER_THICKNESS);
             }

             highlightConcept(idConcept,col, thickness );

         }
    }

    public void newRelation(String fromId0, String fromIdChannel, String toId0, String toIdChannel)
    {
        // add the new relation between fromID and toID
        String fromId = extractDisplayName(fromId0);
        String toId = extractDisplayName(toId0);
        Concept fromConcept = _iph.findBNMatchingConcept(fromId);
        Concept toConcept = _iph.findBNMatchingConcept(toId);

        if (fromConcept == null )
        {
            // create it

            fromConcept = new Concept(fromId);
            fromConcept.put("COMMENT_DISPLAY", fromId0);
            _iph.addConcept(new GraphicalConcept(fromConcept));
        }

        if ( toConcept == null )
        {
            // create it
            toConcept = new Concept(toId);
            toConcept.put("COMMENT_DISPLAY", toId0);
            _iph.addConcept(new GraphicalConcept(toConcept));

        }

        Hashtable fromHt = (Hashtable) fromConcept.getTrans("fromIdChannels");

        if (fromHt == null )
            fromHt = new Hashtable();

        Vector toVec = (Vector) fromHt.get(fromIdChannel);
        if ( toVec == null )
        {
            toVec = new Vector();
        }

        if (! toVec.contains(toIdChannel))
        {
            toVec.add (toIdChannel);
        }

        fromHt.put(fromIdChannel, toVec);
        fromConcept.putTrans("fromIdChannels", fromHt);


        Hashtable toHt = (Hashtable) toConcept.getTrans("toIdChannels");
        if ( toHt == null )
            toHt = new Hashtable();

        if ( toHt.get(toIdChannel) == null )
            toHt.put(toIdChannel, fromIdChannel);

        toConcept.putTrans("toIdChannels", toHt);



        // if there is an existing link between from and to, then set it as a continuing interaction
        // if this is the first time, set it as an intial interaction
        // we need to work out a timer for latent interactions
        GraphicalConcept fromGC = (GraphicalConcept) fromConcept.getGraphicalRepRefs().nextElement();
        GraphicalConcept toGC = (GraphicalConcept) toConcept.getGraphicalRepRefs().nextElement();

        LinkingPhrase lp = _iph.findLinkingPhrase("interaction",fromConcept.getOutgoingConnectionRefs(), false);
        GraphicalLinkingPhrase glp;

        if (( lp == null ) || (! sameChannelLink(lp,fromIdChannel, toIdChannel)))                // since we check for the same link based on channel ids,
        {
            lp = new LinkingPhrase(_cmc.getGraphicalConceptMapRef().getConceptMapRef(), "interaction");
            glp = new GraphicalLinkingPhrase(lp );
            GraphicalConnection gc1 = _iph.addChildNode(fromGC, glp );
            GraphicalConnection gc2 = _iph.addParentNode( glp, toGC );

            gc1.setStyleSheet(InteractionStyles.getInitialInteractionStyles());
            gc2.setStyleSheet(InteractionStyles.getInitialInteractionStyles());

        }
        else
        {
            System.out.println("Found a previous interaction");                                  // if we find it, we should always be able to update its styles.
            GraphicalConnection[] gcons = _iph.findConnections(fromConcept, lp, toConcept);
            if ( gcons[0] != null )
                gcons[0].setStyleSheet(InteractionStyles.getContinuedInteractionStyles());
            else
                System.out.println("Can't set gcons[0]");

            if ( gcons[1] != null )
                gcons[1].setStyleSheet(InteractionStyles.getContinuedInteractionStyles());
            else
            {
                System.out.println("Can't set gcons[1]");
            }
        }

        
        lp.putTrans("fromChannel", fromIdChannel);
        lp.putTrans("toChannel", toIdChannel);
    }

    boolean sameChannelLink( LinkingPhrase lp, String fromIdChannel, String toIdChannel )
    {
        if ( lp != null )
        {
            String storedFIC = (String) lp.getTrans("fromChannel");
            String storedTIC = (String) lp.getTrans("toChannel");

            return ( storedFIC.equals(fromIdChannel) && storedTIC.equals(toIdChannel));
        }

        return false;
    }

    boolean isType( Concept c, String type )
    {
        Object obj = c.get(Constants.NODE_TYPE);
        if (obj == null)
        {
            return false;
        }

        if (obj instanceof ExtVector)
        {
            ExtVector nodeType = (ExtVector)obj;
            return ((nodeType != null) && (nodeType.contains(type)));
        }
        else if (obj instanceof String)
        {
            return ((String)obj).contains(type);
        }
        else
        {
            return false;
        }
    }

    boolean isClass( Concept c )
    {
        return isType(c,Constants.OWL_CLASS);
    }

    boolean isIndiv( Concept c )
    {
        return isType(c,Constants.INDIV);
    }

    boolean isLiteral( Concept c )
    {
        return isType(c,Constants.LITERAL);
    }
}
