package coi.cmap.monitor;

import com.intellij.uiDesigner.core.Spacer;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import core.base.*;
import core.exception.InvalidMenuItemParamXcp;
import core.exception.InvalidMenuItemXcp;
import core.exception.InvalidMenuParamXcp;
import core.exception.InvalidMenuXcp;
import nlk.code.owlimport.OWLImportMod;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: tom
 * Date: Dec 22, 2006
 * Time: 10:03:53 AM
 * To change this template use File | Settings | File Templates.
 */
public class PolicyViewer extends CoreWnd {
    private JPanel mainPanel;
    private JList policies;
    private JButton showButton;
    private JButton removeButton;
    private JButton closeButton;
    private Hashtable policyTable;
    private Vector policyNameVec;
    PolicyViewer _thisWnd;

    public PolicyViewer(Core core) {
        super(core);
        _thisWnd = this;
        policyNameVec = new Vector();

        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(BorderLayout.CENTER, mainPanel);

        showButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("You selected Show");
                showSelectedPolicy();
            }
        });
        removeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("You selected Remove");
            }
        });
        closeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("You selected Close");
                _thisWnd.setVisible(false);
                // _thisWnd.destroy();
            }
        });

        mainPanel.setSize(250, 400);

        policies.setCellRenderer(new PolicyPairCellRenderer());

        MouseListener CEMouseListener = new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                if (e.getClickCount() == 2) {
                    int index = policies.locationToIndex(e.getPoint());
                    System.out.println("Double clicked on Item " + index);
                    showSelectedPolicy();

                    // now display the owl

                }
            }
        };

        policies.addMouseListener(CEMouseListener);


    }

    private void showSelectedPolicy() {
        String selectedPolicyName = (String) policies.getSelectedValue();
        String selectedOWL = (String) policyTable.get(selectedPolicyName);
        System.out.println("Show owl policy for " + selectedPolicyName + " : " + selectedOWL);

        try {
//            CMapComponent cmc = RefactorMod.getRefactorMod().newCMap();

            File tempFile = new File(selectedPolicyName + ".owl");
            tempFile.deleteOnExit();
            FileWriter fw = new FileWriter(tempFile);
            fw.write(selectedOWL);
            fw.close();

            OWLImportMod.getOWLImportMod().createOntologyCmap(tempFile);
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void initialize(Hashtable ht) {
        policyTable = ht;

        for (Enumeration e = ht.keys(); e.hasMoreElements();) {
            String key = (String) e.nextElement();
            policyNameVec.add(key);
        }

        Collections.sort(policyNameVec);
        policies.setListData(policyNameVec);
    }

    {
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
        $$$setupUI$$$();
    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$() {
        mainPanel = new JPanel();
        mainPanel.setLayout(new BorderLayout(10, 10));
        final JLabel label1 = new JLabel();
        label1.setText("Policies for ");
        mainPanel.add(label1, BorderLayout.NORTH);
        final JScrollPane scrollPane1 = new JScrollPane();
        mainPanel.add(scrollPane1, BorderLayout.CENTER);
        policies = new JList();
        scrollPane1.setViewportView(policies);
        final JPanel panel1 = new JPanel();
        panel1.setLayout(new FormLayout("fill:d:grow", "center:d:noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow,top:4dlu:noGrow,center:d:grow,top:4dlu:noGrow,center:max(d;4px):noGrow"));
        mainPanel.add(panel1, BorderLayout.EAST);
        showButton = new JButton();
        showButton.setText("Show");
        CellConstraints cc = new CellConstraints();
        panel1.add(showButton, cc.xy(1, 1));
        removeButton = new JButton();
        removeButton.setText("Remove");
        panel1.add(removeButton, cc.xy(1, 3));
        closeButton = new JButton();
        closeButton.setText("Close");
        closeButton.setVerticalAlignment(0);
        panel1.add(closeButton, cc.xy(1, 7, CellConstraints.DEFAULT, CellConstraints.CENTER));
        final Spacer spacer1 = new Spacer();
        panel1.add(spacer1, cc.xy(1, 5, CellConstraints.DEFAULT, CellConstraints.FILL));
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$() {
        return mainPanel;
    }

    class PolicyPairCellRenderer extends JLabel implements ListCellRenderer {
        public Component getListCellRendererComponent(
                JList list,
                Object value,            // value to display
                int index,
                boolean isSelected,      // is the cell selected
                boolean cellHasFocus)    // the list and the cell have the focus
        {
            String s = (String) value;
            setText(s);
            if (isSelected) {
                setBackground(list.getSelectionBackground());
                setForeground(list.getSelectionForeground());
            } else {
                setBackground(list.getBackground());
                setForeground(list.getForeground());
            }
            setEnabled(list.isEnabled());
            setFont(list.getFont());
            setOpaque(true);
            return this;
        }
    }


    /**
     * This methods are overridden so that no menu appears in the Policy window
     */
    protected void addMenu(String menuSpec, MenuParams menuParams)
            throws InvalidMenuXcp, InvalidMenuParamXcp {
    }

    protected void addMenuItem(String menuSpec, MenuItemParams menuItemParams)
            throws InvalidMenuItemXcp, InvalidMenuItemParamXcp {
    }

    protected void removeMenu(String menuSpec)
            throws InvalidMenuXcp {
    }

    protected void removeMenuItem(String menuSpec)
            throws InvalidMenuItemXcp {
    }

    protected void registerForMenuItemEnableVoting(Module mod,
                                                   String menuSpec,
                                                   boolean initialVote)
            throws InvalidMenuItemXcp {
    }

    public void windowDeactivated(WindowEvent e) {
        if (_bWndClosed || _core == null) {
            return;
        }
        //_core.postWndEvt (_thisCoreWnd, new WndDeactivatedEvt(_thisCoreWnd));
    }


    /**
     * Returns a text string that identifies the window type
     * of this Core window.
     *
     * @return the window type of a Core window
     */
    public static String getStaticWndType() {
        return WND_TYPE;
    }

    /**
     * Returns a text string that identifies the menu Container type
     * of this CoreMenuContainer.
     *
     * @return the container type of this CoreMenuContainer Class
     */
    public String getContainerType() {
        return WND_TYPE;
    }

    private static final String WND_TYPE = "PolicyWnd";

}
