package coi.cmap.monitor;

import coi.relationMonitor.RelationInfo;
import com.intellij.uiDesigner.core.GridConstraints;
import com.intellij.uiDesigner.core.GridLayoutManager;
import com.intellij.uiDesigner.core.Spacer;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class RelationInfoDlg extends JDialog
{
    private JPanel contentPane;
    private JButton buttonOK;
    private JButton buttonCancel;
    private JPanel RelInfoPanel;
    private JList fromList;
    private JList toList;
    private MonitorMapHelper _mmh;
    private RelationInfoPanel _rip;
    private JList typeList;
    private JLabel lastInfoTypeSentLbl;
    private JLabel firstCommLbl;
    private JLabel lastCommLbl;
    private JLabel periodBtwnCommsLbl;
    private JLabel numSentLbl;
    private JLabel commFreqLbl;
    private JSplitPane topSplitPane;


    public RelationInfoDlg()
    {

        $$$setupUI$$$();

        setContentPane(contentPane);
        // setModal(true);
        getRootPane().setDefaultButton(buttonOK);

        buttonOK.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                onOK();
            }
        });

        buttonCancel.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                onCancel();
            }
        });

// call onCancel() when cross is clicked
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                onCancel();
            }
        });

// call onCancel() on ESCAPE
        contentPane.registerKeyboardAction(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                onCancel();
            }
        }, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);

        toList.setCellRenderer(new HashListCellRenderer());
        fromList.setCellRenderer(new HashListCellRenderer());
    }


    public RelationInfoDlg(final String kaosid, String fromIdChannel, final String partnerid, String toIdChannel, MonitorMapHelper mmh)
    {
        this();


        Component comp = topSplitPane.getRightComponent();
        contentPane.remove(topSplitPane);
        contentPane.add(comp, new CellConstraints().xyw(3, 3, 4, CellConstraints.DEFAULT, CellConstraints.FILL));


//        topSplitPane.setDividerLocation(0);
        String kid = kaosid;
        String pid = partnerid;

        _mmh = mmh;
        int kidHashPos = kaosid.indexOf("#");
        if (kidHashPos > 0)
        {
            kid = kaosid.substring(kidHashPos + 1);
        }

        int pidHashPos = partnerid.indexOf("#");
        if (pidHashPos > 0)
        {
            pid = partnerid.substring(pidHashPos + 1);
        }

        setTitle("Relation Info from " + kid + " to " + pid);

        fromList.setListData(new Object[]{kaosid});

        toList.setListData(new Object[]{partnerid});

        System.out.println("From " + fromIdChannel + " to " + toIdChannel);
        setRelationInfo(partnerid, fromIdChannel, toIdChannel);

    }

    public RelationInfoDlg(final String kaosid, final Hashtable fromHt, MonitorMapHelper mmh)
    {
        this();

        _mmh = mmh;

        String ikid = kaosid;
        int kidHashPos = kaosid.indexOf("#");
        if (kidHashPos > 0)
        {
            ikid = kaosid.substring(kidHashPos + 1);
        }

        final String kid = ikid;
        setTitle("Relation Info from " + kid + " to ...");
        fromList.setListData(new Vector(fromHt.keySet()));
        fromList.addListSelectionListener(new ListSelectionListener()
        {
            public void valueChanged(ListSelectionEvent e)
            {
                Vector partnerVec = new Vector();
                final String fromIdChannel = (String) ((JList) e.getSource()).getModel().getElementAt(e.getFirstIndex());
                final String fromIdName1 = (String) _mmh.channelsToProducers.get(fromIdChannel);
                System.out.println("From name is " + fromIdName1);
                try
                {
                    Vector partners = (Vector) fromHt.get(fromIdChannel);

//                    Map partners = _mmh.queryRelations(kaosid, fromIdChannel);
                    if (partners != null)
                    {
                        for (Iterator it = partners.iterator(); it.hasNext();)
                        {
                            Object key = it.next();
                            partnerVec.add(key);
                        }

                        setTitle("Relation Info from " + kid + " to ...");
                        toList.setListData(partnerVec);

                    }
                }
                catch (Exception exp)
                {
                    exp.printStackTrace();
                }
                toList.addListSelectionListener(new ListSelectionListener()
                {
                    public void valueChanged(ListSelectionEvent e)
                    {
                        String tochannel = (String) ((JList) e.getSource()).getModel().getElementAt(e.getFirstIndex());

                        String fromIdName = (String) _mmh.channelsToConsumers.get(tochannel);
                        if (fromIdName != null)
                        {
                            int pidHashPos = fromIdName.indexOf("#");
                            String pid = fromIdName;
                            if (pidHashPos > 0)
                            {
                                pid = fromIdName.substring(pidHashPos + 1);
                            }

                            setTitle("Relation Info from " + kid + " to " + pid);
                        }

                        setRelationInfo(fromIdName, fromIdChannel, tochannel);

                    }
                });
            }
        });
    }


    private void setRelationInfo(String kaosid, String fromIdChannel, String toIdChannel)
    {
        System.out.println("0:" + kaosid + " 1:" + fromIdChannel + " 2:" + toIdChannel);
        try
        {
            Map rels = _mmh.queryRelations(kaosid, toIdChannel);
            if (rels != null)
            {
                RelationInfo ri = (RelationInfo) rels.get(fromIdChannel);
                if (ri != null)
                {
                    setInfo(ri);
                }
            }
        }
        catch (Exception e1)
        {
            e1.printStackTrace();
        }
    }

    private void onOK()
    {
// add your code here
        dispose();
    }

    private void onCancel()
    {
// add your code here if necessary
        dispose();
    }


    public void setInfo(RelationInfo ri)
    {
        setLastInfoTypeSentLbl(ri._lastInfoObjectType);
        setLastCommLbl(ri._lastComm.toString());
        setFirstCommLbl(ri._firstComm.toString());
        setPeriodBtwnCommsLbl(Float.toString(ri._periodBetweenComm));
        setNumSentLbl(Integer.toString(ri._noOfSentInfoObjects));
        setCommFreqLbl(Float.toString(ri._commFreq));
        setTypeList(ri._allInfoObjectTypesSent);

    }

    public Set getTypeList()
    {
        Set res = new HashSet();
        ListModel m = typeList.getModel();
        for (int i = 0; i < m.getSize(); i++)
        {
            res.add(m.getElementAt(i));
        }
        return res;
    }

    public void setTypeList(Set typeList)
    {
        Vector v = new Vector(typeList);
        this.typeList.setListData(v);
    }

    public String getLastInfoTypeSentLbl()
    {
        return lastInfoTypeSentLbl.getText();
    }

    public void setLastInfoTypeSentLbl(String lastInfoTypeSentLbl)
    {
        this.lastInfoTypeSentLbl.setText(stripHash(lastInfoTypeSentLbl));
    }

    public String getFirstCommLbl()
    {
        return firstCommLbl.getText();
    }

    public void setFirstCommLbl(String firstCommLbl)
    {
        this.firstCommLbl.setText(firstCommLbl);
    }

    public String getLastCommLbl()
    {
        return lastCommLbl.getText();
    }

    public void setLastCommLbl(String lastCommLbl)
    {
        this.lastCommLbl.setText(lastCommLbl);
    }

    public String getPeriodBtwnCommsLbl()
    {
        return periodBtwnCommsLbl.getText();
    }

    public void setPeriodBtwnCommsLbl(String periodBtwnCommsLbl)
    {
        this.periodBtwnCommsLbl.setText(periodBtwnCommsLbl);
    }

    public String getNumSentLbl()
    {
        return numSentLbl.getText();
    }

    public void setNumSentLbl(String numSentLbl)
    {
        this.numSentLbl.setText(numSentLbl);
    }

    public String getCommFreqLbl()
    {
        return commFreqLbl.getText();
    }

    public void setCommFreqLbl(String commFreqLbl)
    {
        this.commFreqLbl.setText(commFreqLbl);
    }


    private void createUIComponents()
    {
        _rip = new RelationInfoPanel();
        RelInfoPanel = _rip.getMainPanel();

    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$()
    {
        contentPane = new JPanel();
        contentPane.setLayout(new FormLayout("fill:max(d;4px):noGrow,left:4dlu:noGrow,fill:max(d;4px):noGrow,left:4dlu:noGrow,fill:d:grow,left:4dlu:noGrow,fill:max(d;4px):noGrow", "center:max(d;4px):noGrow,top:4dlu:noGrow,center:d:grow,top:4dlu:noGrow,center:max(d;4px):noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow"));
        final JPanel panel1 = new JPanel();
        panel1.setLayout(new GridLayoutManager(1, 2, new Insets(0, 0, 0, 0), -1, -1));
        CellConstraints cc = new CellConstraints();
        contentPane.add(panel1, cc.xy(5, 5));
        final Spacer spacer1 = new Spacer();
        panel1.add(spacer1, new GridConstraints(0, 0, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_HORIZONTAL, GridConstraints.SIZEPOLICY_WANT_GROW, 1, null, null, null, 0, false));
        final JPanel panel2 = new JPanel();
        panel2.setLayout(new FormLayout("fill:d:grow,left:4dlu:noGrow,fill:d:grow", "center:d:grow"));
        panel1.add(panel2, new GridConstraints(0, 1, 1, 1, GridConstraints.ANCHOR_CENTER, GridConstraints.FILL_BOTH, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, GridConstraints.SIZEPOLICY_CAN_SHRINK | GridConstraints.SIZEPOLICY_CAN_GROW, null, null, null, 0, false));
        buttonCancel = new JButton();
        buttonCancel.setText("Cancel");
        panel2.add(buttonCancel, cc.xy(1, 1));
        buttonOK = new JButton();
        buttonOK.setText("OK");
        panel2.add(buttonOK, cc.xy(3, 1));
        topSplitPane = new JSplitPane();
        contentPane.add(topSplitPane, cc.xyw(3, 3, 4, CellConstraints.DEFAULT, CellConstraints.FILL));
        RelInfoPanel = new JPanel();
        RelInfoPanel.setLayout(new FormLayout("fill:d:noGrow,left:4dlu:noGrow,fill:max(d;4px):noGrow", "center:max(d;4px):noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow,top:4dlu:noGrow,center:max(d;4px):noGrow"));
        topSplitPane.setRightComponent(RelInfoPanel);
        final JLabel label1 = new JLabel();
        label1.setText("Last info type sent:");
        RelInfoPanel.add(label1, cc.xy(1, 1));
        lastInfoTypeSentLbl = new JLabel();
        lastInfoTypeSentLbl.setText("");
        RelInfoPanel.add(lastInfoTypeSentLbl, cc.xy(3, 1));
        final JLabel label2 = new JLabel();
        label2.setText("First Communication:");
        RelInfoPanel.add(label2, cc.xy(1, 3));
        final JLabel label3 = new JLabel();
        label3.setText("Last Communication:");
        RelInfoPanel.add(label3, cc.xy(1, 5));
        final JLabel label4 = new JLabel();
        label4.setText("Info Types sent:");
        RelInfoPanel.add(label4, cc.xy(1, 7, CellConstraints.DEFAULT, CellConstraints.TOP));
        final JLabel label5 = new JLabel();
        label5.setText("Period between comms:");
        RelInfoPanel.add(label5, cc.xy(1, 9));
        final JScrollPane scrollPane1 = new JScrollPane();
        RelInfoPanel.add(scrollPane1, cc.xy(3, 7, CellConstraints.FILL, CellConstraints.FILL));
        typeList = new JList();
        scrollPane1.setViewportView(typeList);
        final JLabel label6 = new JLabel();
        label6.setText("# of Objects sent:");
        RelInfoPanel.add(label6, cc.xy(1, 11));
        periodBtwnCommsLbl = new JLabel();
        periodBtwnCommsLbl.setText("");
        RelInfoPanel.add(periodBtwnCommsLbl, cc.xy(3, 9));
        numSentLbl = new JLabel();
        numSentLbl.setText("");
        RelInfoPanel.add(numSentLbl, cc.xy(3, 11));
        final JLabel label7 = new JLabel();
        label7.setText("Communication Freq:");
        RelInfoPanel.add(label7, cc.xy(1, 13));
        commFreqLbl = new JLabel();
        commFreqLbl.setText("");
        RelInfoPanel.add(commFreqLbl, cc.xy(3, 13));
        lastCommLbl = new JLabel();
        lastCommLbl.setText("");
        RelInfoPanel.add(lastCommLbl, cc.xy(3, 5));
        firstCommLbl = new JLabel();
        firstCommLbl.setText("");
        RelInfoPanel.add(firstCommLbl, cc.xy(3, 3));
        final JPanel panel3 = new JPanel();
        panel3.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
        topSplitPane.setLeftComponent(panel3);
        final JSplitPane splitPane1 = new JSplitPane();
        splitPane1.setOrientation(0);
        panel3.add(splitPane1);
        final JPanel panel4 = new JPanel();
        panel4.setLayout(new FormLayout("fill:d:noGrow", "center:d:noGrow,top:4dlu:noGrow,center:d:grow"));
        splitPane1.setLeftComponent(panel4);
        final JLabel label8 = new JLabel();
        label8.setText("Producer Channels");
        panel4.add(label8, cc.xy(1, 1));
        final JScrollPane scrollPane2 = new JScrollPane();
        panel4.add(scrollPane2, cc.xy(1, 3, CellConstraints.FILL, CellConstraints.FILL));
        fromList = new JList();
        scrollPane2.setViewportView(fromList);
        final JPanel panel5 = new JPanel();
        panel5.setLayout(new FormLayout("fill:d:noGrow", "center:d:noGrow,top:4dlu:noGrow,center:d:grow"));
        splitPane1.setRightComponent(panel5);
        final JLabel label9 = new JLabel();
        label9.setText("Consumer Channels");
        panel5.add(label9, cc.xy(1, 1));
        final JScrollPane scrollPane3 = new JScrollPane();
        panel5.add(scrollPane3, cc.xy(1, 3, CellConstraints.FILL, CellConstraints.FILL));
        toList = new JList();
        scrollPane3.setViewportView(toList);
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$()
    {
        return contentPane;
    }

    public class HashListCellRenderer extends JLabel implements ListCellRenderer
    {

        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
        {
            String s = value.toString();
            s = stripHash(s);
            setText(s);
            if (isSelected)
            {
                setBackground(list.getSelectionBackground());
                setForeground(list.getSelectionForeground());
            }
            else
            {
                setBackground(list.getBackground());
                setForeground(list.getForeground());
            }
            setEnabled(list.isEnabled());
            setFont(list.getFont());
            setOpaque(true);
            return this;
        }

    }

    private String stripHash(String s)
    {
        int hIndx = s.indexOf("#");
        if ((hIndx > 0) && (!s.endsWith("#")))
            s = s.substring(hIndx + 1);
        return s;
    }


}
