package coi.jbi.client;

import org.infospherics.jbi.client.InfoObject;
import org.infospherics.jbi.client.PayloadCallback;
import org.infospherics.jbi.client.exception.InvalidAttributeXMLException;
import org.infospherics.jbi.client.exception.PausedSequenceException;
import org.infospherics.jbi.client.exception.PermissionDeniedException;
import org.infospherics.jbi.client.exception.PlatformFailureException;
import org.infospherics.jbi.client.exception.SequenceStateException;
import org.infospherics.jbi.client.exception.StaleSequenceUIDException;
import org.infospherics.jbi.client.exception.UnimplementedException;
import org.infospherics.jbi.client.exception.UnknownAttributeException;

public class PublisherSequence implements org.infospherics.jbi.client.PublisherSequence 
{
	private org.infospherics.jbi.client.PublisherSequence 	_publisherSequence;
	
	public PublisherSequence(org.infospherics.jbi.client.PublisherSequence pubSequence) 
    {
		_publisherSequence = pubSequence;
	}

	public String publishInfoObject(InfoObject IO) throws PausedSequenceException, PlatformFailureException, PermissionDeniedException, SequenceStateException 
    {
		// TODO: Implement KAoS-policy checking here!!!
		//Retrieve from the InfoObject action name, property and check policies
        
		return _publisherSequence.publishInfoObject(IO);
	}

	public void setPayloadCallback(PayloadCallback callback) throws PlatformFailureException, UnimplementedException, SequenceStateException 
	{
		_publisherSequence.setPayloadCallback(callback);
	}

	public int setSequenceAttribute(String attributeTypeName, String version, String attributeXML) 
		throws PermissionDeniedException, InvalidAttributeXMLException, UnknownAttributeException, PlatformFailureException, SequenceStateException 
    {
		return _publisherSequence.setSequenceAttribute(attributeTypeName, version, attributeXML); 
	}

	public void removeSequenceAttribute(String attributeTypeName, String version)
	     throws PermissionDeniedException, UnknownAttributeException, PlatformFailureException, StaleSequenceUIDException, SequenceStateException 
    {		
		_publisherSequence.removeSequenceAttribute(attributeTypeName,version);
	}

	public String getSequenceAttribute(String attributeTypeName, String version)
		throws PlatformFailureException, PermissionDeniedException, SequenceStateException 
    {
		return _publisherSequence.getSequenceAttribute(attributeTypeName, version);
	}

	public void activateSequence() throws PlatformFailureException, PermissionDeniedException, SequenceStateException
	{
		_publisherSequence.activateSequence();
	}

	public void pauseSequence() throws PlatformFailureException, PermissionDeniedException 
    {
		_publisherSequence.pauseSequence();
	}

	public int getSequenceState() throws PlatformFailureException, PermissionDeniedException 
	{
		return _publisherSequence.getSequenceState();
	}
	
	public void resumeSequence() throws PlatformFailureException, PermissionDeniedException, SequenceStateException 
	{
		_publisherSequence.resumeSequence();
	}

	public String getInfoObjectTypeName() 
	{
		return _publisherSequence.getInfoObjectTypeName();
	}

	public String getInfoObjectVersion()
	{
		return _publisherSequence.getInfoObjectVersion();
	}
}
