package coi.jbi.demo.metoc;

public class OntologyConcepts
{
    // Namespace to locate OWL Classes for weather reports
    public static final String WEATHER_PUBLICATIONS_NSPREFIX = "n1";
    public static final String WEATHER_PUBLICATIONS_NAMESPACE = "http://norma.ihmc.us:8082/servlet/SBReadResourceServlet?rid=1165296213152_1891451068_1506&partName=owl#";

    // Weather Sensor Report JBI package and OWL Ontology Class
    public static final String WEATHER_SENSORREPORT_JBI_TYPE = "mil.af.rl.jbi.korea.weather.sensorreport";
    public static final String WEATHER_SENSORREPORT_ACTION_CLASS = WEATHER_PUBLICATIONS_NAMESPACE + "WeatherSensorReport";

    // Namespace for the properties contained in a weather report
    public static final String WEATHER_PROPERTIES_NSPREFIX = "n2";
    public static final String WEATHER_PROPERTIES_NAMESPACE = "http://norma.ihmc.us:8082/servlet/SBReadResourceServlet?rid=1166110976546_1424443183_1197&partName=owl#";

    // A weather sensor report contains AirTemp, WindSpeed, and Visiblity individuals
    public static final String WEATHER_PROPERTY_CONTAINS = WEATHER_PUBLICATIONS_NAMESPACE + "contains";
    public static final String WEATHER_CLASS_AIR_TEMP = WEATHER_PROPERTIES_NAMESPACE + "AirTemperature";
    public static final String WEATHER_CLASS_WIND_SPEED_AVG = WEATHER_PROPERTIES_NAMESPACE + "WindSpeedAvg";
    public static final String WEATHER_CLASS_VISIBILITY = WEATHER_PROPERTIES_NAMESPACE + "Visibility";

    // All weather report properties (AirTemp, WindSpeed, and Visiblity) have a value (float) and a units (string)
    public static final String WEATHER_PROPERTY_HAS_UNITS = WEATHER_PROPERTIES_NAMESPACE + "hasUnit";
    public static final String WEATHER_PROPERTY_HAS_VALUE = WEATHER_PROPERTIES_NAMESPACE + "hasValue";
    public static final String WEATHER_PROPERTY_HAS_TEXT = WEATHER_PROPERTIES_NAMESPACE + "hasText";


    public static final String WEATHER_WARNING_JBI_TYPE = "mil.af.rl.jbi.korea.weather.warning";
    public static final String WEATHER_WARNING_ACTION_CLASS = WEATHER_PUBLICATIONS_NAMESPACE + "WeatherWarning%20(WW)";

    public static final String MISSION_CONTROL_FORECAST_TYPE = "mil.af.rl.jbi.korea.weather.missioncontrolforecast";
    public static final String MISSION_CONTROL_FORECAST_ACTION_CLASS = WEATHER_PUBLICATIONS_NAMESPACE + "MissionControlForecast%20(MCF)";

}