/**
 * 
 */
package coi.ontologyAnnotation;

import kaos.core.csi.CSIFactory;

/**
 * @author rjeffers
 *
 */
public interface OntologyAnnotationConstants {
	/*
	 * ONTOLOGY_ANNOTATION_SERVICE_SECTION usage:  this constant is defined in the guardConfiguartion
	 * file, as the title of the section describing the OntologyAnnotationService.
	 * This constant is used to retrieve the KAoSExtensionComponentManager for the service, OntologyAnnotationManager:
	 * 	serviceMgr = CSIFactory.getKAoSExtensionComponentManager(OntologyAnnotationConstants.ONTOLOGY_ANNOTATION_SERVICE_SECTION);
	 */
	String ONTOLOGY_ANNOTATION_SERVICE_SECTION = "ontology-annotation-service";  
	
	/*
	 * ONTOLOGY_ANNOTATION_MANAGER_TYPE  usage: this constant is defined in the guardConfiguration
	 * file to specify the type of the KAoSExtensionComponentManagerImpl. KAoSExtensionComponentManagerImpl
	 * uses this name to retrieve the mapping of ont type -> class name in order
	 * to instantiate the service.
	 */
	String ONTOLOGY_ANNOTATION_MANAGER_TYPE = "OntologyAnnotation";
	
	/*
	 * ONTOLOGY_ANNOTATION_SERVICE_OPERATIONS  usage: this constant is defined in the guardConfiguration
	 * file to specify the ontological operations the service is capable of performing. 
	 */
	String ONTOLOGY_ANNOTATION_SERVICE_OPERATIONS = "OntologicalOperations";
	
	/*
	 * ONTOLOGY_ANNOTATION_SERVICE usage: this constant is defined in the guardConfiguartion
	 * file, as the ont type of the service.  It is used as the argument of the method 
	 * in OntologyAnnotationManager to get a reference to the service:
	 * 
	 * ontManager.getOntologyAnnotationService(ONTOLOGY_ANNOTATION_SERVICE);
	 */
    String ONTOLOGY_ANNOTATION_SERVICE = "http://ontology.ihmc.us/OntologyAnnotation.owl#OntologyAnnotationService";
    
    
}
