/**
 * Last Modified by: $Author: rjeffers $
 * On: $Date: 2006/08/01 22:20:14 $
 */
package coi.ontologyAnnotation;

import kaos.core.csi.extension.KAoSExtensionComponentManager;

/**
*
* This interface defines a factory method for obtaining an OntologyAnnotationService,
* whose  ontological type is given.
*
* $Revision: 1.1 $	
*
*/
public interface OntologyAnnotationManager 
	extends KAoSExtensionComponentManager {
	
	/**
	 * Return an OntologyAnnotationService. 
	 * 
	 * @param ontType	String describing the ontological type of the requested service.
	 *
	 * @return OntologyAnnotationService		an instance of the OntologyAnnotationService, or null
	 *     										if the manager is not able to find or create the OntologyAnnotationService
	 *                          
	 */
	
	public OntologyAnnotationService getOntologyAnnotationService(String ontType);


}
