/**
 * Last Modified by: $Author: rjeffers $
 * On: $Date: 2006/08/01 22:20:14 $
 */

package coi.ontologyAnnotation;

import kaos.core.csi.extension.KAoSExtensionComponentManagerImpl;

/**
*
* This class implements the OntologyAnnotationManager interface, which defines a factory method 
* for obtaining an OntologyAnnotationService, whose  ontological type is given.
* 
* $Revision: 1.1 $	
*
*/
public class OntologyAnnotationManagerImpl 
	extends	KAoSExtensionComponentManagerImpl 
	implements OntologyAnnotationManager {

	/**
	 * 
	 */
	private static final long serialVersionUID = -5169643182734644653L;
	private static OntologyAnnotationManager    		__INSTANCE;
	private static boolean                     			__INITIALIZED = false;
	
	/**
	 * 
	 */
	private OntologyAnnotationManagerImpl() {
		super(OntologyAnnotationConstants.ONTOLOGY_ANNOTATION_MANAGER_TYPE);
	}

	
	/**
     * Retrieve an instance of OntologyAnnotationManager.
     *
     * @return a singleton, OntologyAnnotationManagerImpl.
     */
    public static OntologyAnnotationManager getInstance()
    {
        if ( __INITIALIZED ) return __INSTANCE;
        
        __INSTANCE = new OntologyAnnotationManagerImpl();
        __INITIALIZED = true;
            
        return __INSTANCE;
    }
	
	/*****************************************************************************************
    coi.ontologyAnnotation.OntologyAnnotationManager interface implementation  - begin
    *****************************************************************************************/
    /* (non-Javadoc)
	 * @see coi.ontologyAnnotation.OntologyAnnotationManager#getOntologyAnnotationService()
	 */
	public OntologyAnnotationService getOntologyAnnotationService(String ontType) {
		return (OntologyAnnotationService)getComponent(ontType, null);
	}
    /*****************************************************************************************
    coi.ontologyAnnotation.OntologyAnnotationManager interface implementation  - end
   *****************************************************************************************/
}
