/*
 * RelationInfo.java
 *
 * Created on October 6, 2006, 3:05 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package coi.relationMonitor;

import java.io.Serializable;
import java.util.Date;
import java.util.Set;
import java.util.HashSet;

/**
 *  @author jlott
 */
public class RelationInfo implements Serializable
{
    private static final long serialVersionUID = -1818221707389853369L;
    
    public String _lastInfoObjectType;    // last type of the echanged object
    public Set _allInfoObjectTypesSent;   // set containing all the types of the echanged object 
    public Date _firstComm;               // time of the first communicaiton
    public Date _lastComm;                // time of the last recorded communication
    public float _periodBetweenComm;      // time between the last two communications in seconds
    public int _noOfSentInfoObjects;      // number of echanged info objects
    public float _commFreq;               // avarage time between all communication in seconds
    public boolean _isProducer;
   
    // Creates a new instance of RelationInfo
    public RelationInfo (String infoObjectType, Date currentComTime, boolean isProducer)
    {
        _lastInfoObjectType = infoObjectType;
        _allInfoObjectTypesSent = new HashSet();
        _firstComm = currentComTime;
        _lastComm = currentComTime;
        _periodBetweenComm = 0;
        _noOfSentInfoObjects = 1;
        _commFreq = 0;
        _isProducer = isProducer;
    }
    
    public void updateRelationInfo(String currentInfoObjectType, Date currentComTime)
    {
        if ( ! _lastInfoObjectType.equals(currentInfoObjectType))
        {
            _allInfoObjectTypesSent.add(_lastInfoObjectType);
            
            _lastInfoObjectType = currentInfoObjectType;
        }

        _periodBetweenComm = currentComTime.getTime() - _lastComm.getTime();
        
        _commFreq = ((_noOfSentInfoObjects-1)/_noOfSentInfoObjects) * _commFreq + _periodBetweenComm/_noOfSentInfoObjects;
        
        _noOfSentInfoObjects = _noOfSentInfoObjects + 1;
        
        _lastComm = currentComTime;
    }  
}
