/**
 * Last Modified by: $Author: teskridg $
 * On: $Date: 2007/04/17 00:09:34 $
 */
 
package coi.relationMonitor;

import java.util.Map;

/**
 * The interface of the service allowing to report relation activity between actors
 */
public interface RelationMonitorService 
{
    public static final String RELATION_MONITOR_SERVICE_URL = "http://ontology.ihmc.us/RelationMonitor.owl#RelationMonitorService";
    public static final String NEW_RELATION_UPDATE = "newRelationUpdate";
    public static final String NEW_PRODUCER_CHANNEL_UPDATE = "newProducerChannelUpdate";
    public static final String NEW_CONSUER_CHANNEL_UPDATE = "newConsumerChannelUpdate";
    
    public static final String CONSUMER_ID = "CunsumerID";
    public static final String PRODUCER_ID = "ProducerID";
    
    public void reportRelation (String fromId, String toId, String infoObjectType, boolean isProducer);
    
    public void reportProducerChannel (String producerId, String channelId, String infoObjectType);
    
    public void reportConsumerChannel (String consumerId, String channelId, String infoObjectType);
    
    // returns Map of entityId -> RelationInfo
    public Map queryRelations (String id);
    public Map getRelations();
}
