/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2007/03/28 22:53:20 $
 */

package coi.semanticTranslator;

import kaos.core.csi.extension.KAoSExtensionComponentManagerImpl;

/**
 *
 * This class implements the SemanticTranslatorManager interface, which defines a factory method 
 * for obtaining a SemanticTranslatorService, whose  ontological type is given.
 * 
 * $Revision: 1.1 $	
 */
public class SemanticTranslatorManager extends	KAoSExtensionComponentManagerImpl 
{
    private static final long serialVersionUID = 6517913131748452151L;

    public static final String SEMANTIC_TRANSLATOR_MANAGER_TYPE = "SemanticTranslator";
    
	private static SemanticTranslatorManager    		__INSTANCE;
	private static boolean                     			__INITIALIZED = false;
	
	/**
	 * 
	 */
	private SemanticTranslatorManager() 
    {
		super(SEMANTIC_TRANSLATOR_MANAGER_TYPE);
	}

	/**
     * Retrieve an instance of SemanticTranslatorManager.
     * 
     * @return a singleton, SemanticTranslatorManager.
     */
    public static SemanticTranslatorManager getInstance()
    {
        if ( __INITIALIZED ) return __INSTANCE;
        
        __INSTANCE = new SemanticTranslatorManager();
        __INITIALIZED = true;
            
        return __INSTANCE;
    }
}
